/**
  * @file fls_nor_flash_regs.h
  * @author generated by mrt-device utility 
  * @link [https://github.com/uprev-mrt/mrtutils/wiki/mrt-device]
  * @brief values and constants for the fls_nor_flash device registers
  * 
  */

#define FLS_NOR_FLASH_REG_ADDR_SIZE 1
#define FLS_NOR_FLASH_REG_COUNT 7


/*******************************************************************************
  Register Addresses                                                                              
*******************************************************************************/

#define FLS_REG_STATUS_ADDR                                        0x05 /* Status Register */
#define FLS_REG_CONFIG_ADDR                                        0x35 /* Configuration Register */
#define FLS_REG_BANK_ADDR_ADDR                                     0x17 /* Bank Address Register */
#define FLS_REG_SEC_ERASE_ADDR                                     0x20 /* Sector Erase command */
#define FLS_REG_BULK_ERASE_ADDR                                    0x60 /* Bulk Erase command */
#define FLS_REG_PROG_DATA_ADDR                                     0x02 /* Page Program command */
#define FLS_REG_READ_DATA_ADDR                                     0x03 /* Read Data command */


/*******************************************************************************
  Fields                                                                              
*******************************************************************************/

/* STATUS Register Fields */
    /* STATUS -> Flags */
    #define FLS_STATUS_WIP                                         0x01 /* Write In Progress. Device Busy, a Write Registers(WRR), program, erase or otheroperation is in progress */
    #define FLS_STATUS_WEL                                         0x02 /* Write Enable Latch bit. Device accepts Write Registers(WRR), program or erase commands  */
    #define FLS_STATUS_E_ERR                                       0x20 /* Erase Error Occurred */
    #define FLS_STATUS_P_ERR                                       0x40 /* Program Error Occurred */
    #define FLS_STATUS_SRWD                                        0x80 /* Status Register Write Disable bit */
    /* STATUS -> BP */
    #define FLS_STATUS_BP_FIELD_MASK                               0x1C /* Block Protect bits */
    #define FLS_STATUS_BP_FIELD_OFFSET                             0x02
      #define FLS_STATUS_BP_NONE                                   0x00 /* No Memory blocks are protected */
      #define FLS_STATUS_BP_UPPER_64TH                             0x01 /* Upper 1/64th of Memory is protected */
      #define FLS_STATUS_BP_UPPER_32ND                             0x02 /* Upper 1/32nd of Memory is protected */
      #define FLS_STATUS_BP_UPPER_16TH                             0x03 /* Upper 1/16th of Memory is protected */
      #define FLS_STATUS_BP_UPPER_8TH                              0x04 /* Upper 1/8th of Memory is protected */
      #define FLS_STATUS_BP_UPPER_4TH                              0x05 /* Upper 1/4th Memory is protected */
      #define FLS_STATUS_BP_UPPER_HALF                             0x06 /* Upper 1/2 or Memory is protected */
      #define FLS_STATUS_BP_ALL                                    0x07 /* All Memory is protected */
/* CONFIG Register Fields */
    /* CONFIG -> Flags */
    #define FLS_CONFIG_FREEZE                                      0x01 /* Freeze bit. Block Protection and OTP Locked */
    #define FLS_CONFIG_QUAD                                        0x02 /* Quad Enable bit. Enable Quad SPI operation */
    /* CONFIG -> TBPARAM */
    #define FLS_CONFIG_TBPARAM_FIELD_MASK                          0x04 /* Configures parameter Sectors location */
    #define FLS_CONFIG_TBPARAM_FIELD_OFFSET                        0x02
      #define FLS_CONFIG_TBPARAM_LOWER                             0x00 /* 4-KB physical sectors at bottom (lowaddress) */
      #define FLS_CONFIG_TBPARAM_UPPER                             0x01 /* 4-KB physical sectors at top (highaddress) */
    /* CONFIG -> BPNM */
    #define FLS_CONFIG_BPNM_FIELD_MASK                             0x08 /* Congfigures Block Protection bits to be volatile/non-volatile */
    #define FLS_CONFIG_BPNM_FIELD_OFFSET                           0x03
      #define FLS_CONFIG_BPNM_VOLATILE                             0x01 /* Volatile */
      #define FLS_CONFIG_BPNM_NON_VOLATILE                         0x00 /* Non-volatile */
    /* CONFIG -> TBPROT */
    #define FLS_CONFIG_TBPROT_FIELD_MASK                           0x10 /* Configures start of block protection */
    #define FLS_CONFIG_TBPROT_FIELD_OFFSET                         0x04
      #define FLS_CONFIG_TBPROT_BOTTOM                             0x01 /* BP starts at bottom (Low address) */
      #define FLS_CONFIG_TBPROT_TOP                                0x00 /* BP starts at top (High address)  */
    /* CONFIG -> LC */
    #define FLS_CONFIG_LC_FIELD_MASK                               0xC0 /* Selects number of initial read latency cycles, see latency code tables(Table 26 through Table 29) in datasheet */
    #define FLS_CONFIG_LC_FIELD_OFFSET                             0x06
/* BANK_ADDR Register Fields */
    /* BANK_ADDR -> BANK_ADDR */
    #define FLS_BANK_ADDR_BANK_ADDR_FIELD_MASK                     0xFF /* Bank Address Register */
    #define FLS_BANK_ADDR_BANK_ADDR_FIELD_OFFSET                   0x00

/*******************************************************************************
  Default Values                                                                              
*******************************************************************************/

#define FLS_STATUS_DEFAULT                                         0x00
#define FLS_CONFIG_DEFAULT                                         0x00
#define FLS_BANK_ADDR_DEFAULT                                      0x00




/*******************************************************************************
  Flag Set/Clear/Check                                                                             
*******************************************************************************/

/**
  *@brief sets flags on device
  *@param dev ptr to fls_nor_flash device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  */
#define fls_set_flag(dev, reg, mask) regdev_set_flags(&(dev)->mRegDev,(reg), (mask))

/**
  *@brief clears flags on device
  *@param dev ptr to fls_nor_flash device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  */
#define fls_clear_flag(dev, reg, mask) regdev_clear_flags(&(dev)->mRegDev,(reg), (mask))

/**
  *@brief checks flags on device
  *@param dev ptr to fls_nor_flash device
  *@param reg ptr to register definition
  *@param mask mask of flags to set
  *@return true if all flags in mask are set 
  *@return false if any flags in mask are not set
  */
#define fls_check_flag(dev, reg, mask) regdev_check_flags(&(dev)->mRegDev,(reg), (mask))

/*******************************************************************************
  Field Getters                                                                              
*******************************************************************************/

/**
 * @brief reads the BP field from the STATUS register 
 * @param dev ptr to fls_nor_flash device
 * @return FLS_STATUS_BP_NONE No Memory blocks are protected
 * @return FLS_STATUS_BP_UPPER_64TH Upper 1/64th of Memory is protected
 * @return FLS_STATUS_BP_UPPER_32ND Upper 1/32nd of Memory is protected
 * @return FLS_STATUS_BP_UPPER_16TH Upper 1/16th of Memory is protected
 * @return FLS_STATUS_BP_UPPER_8TH Upper 1/8th of Memory is protected
 * @return FLS_STATUS_BP_UPPER_4TH Upper 1/4th Memory is protected
 * @return FLS_STATUS_BP_UPPER_HALF Upper 1/2 or Memory is protected
 * @return FLS_STATUS_BP_ALL All Memory is protected
 */
#define fls_get_status_bp(dev) regdev_read_field(&(dev)->mRegDev, &(dev)->mStatus, FLS_STATUS_BP_FIELD_MASK )
/**
 * @brief reads the TBPARAM field from the CONFIG register 
 * @param dev ptr to fls_nor_flash device
 * @return FLS_CONFIG_TBPARAM_LOWER 4-KB physical sectors at bottom (lowaddress)
 * @return FLS_CONFIG_TBPARAM_UPPER 4-KB physical sectors at top (highaddress)
 */
#define fls_get_config_tbparam(dev) regdev_read_field(&(dev)->mRegDev, &(dev)->mConfig, FLS_CONFIG_TBPARAM_FIELD_MASK )
/**
 * @brief reads the BPNM field from the CONFIG register 
 * @param dev ptr to fls_nor_flash device
 * @return FLS_CONFIG_BPNM_VOLATILE Volatile
 * @return FLS_CONFIG_BPNM_NON_VOLATILE Non-volatile
 */
#define fls_get_config_bpnm(dev) regdev_read_field(&(dev)->mRegDev, &(dev)->mConfig, FLS_CONFIG_BPNM_FIELD_MASK )
/**
 * @brief reads the TBPROT field from the CONFIG register 
 * @param dev ptr to fls_nor_flash device
 * @return FLS_CONFIG_TBPROT_BOTTOM BP starts at bottom (Low address)
 * @return FLS_CONFIG_TBPROT_TOP BP starts at top (High address) 
 */
#define fls_get_config_tbprot(dev) regdev_read_field(&(dev)->mRegDev, &(dev)->mConfig, FLS_CONFIG_TBPROT_FIELD_MASK )
/**
 * @brief reads the LC field from the CONFIG register 
 * @param dev ptr to fls_nor_flash device
 */
#define fls_get_config_lc(dev) regdev_read_field(&(dev)->mRegDev, &(dev)->mConfig, FLS_CONFIG_LC_FIELD_MASK )
/**
 * @brief reads the BANK_ADDR field from the BANK_ADDR register 
 * @param dev ptr to fls_nor_flash device
 */
#define fls_get_bank_addr(dev) regdev_read_field(&(dev)->mRegDev, &(dev)->mBankAddr, FLS_BANK_ADDR_BANK_ADDR_FIELD_MASK )


/*******************************************************************************
  Field Setters                                                                              
*******************************************************************************/


/*******************************************************************************
  Configs                                                                            
*******************************************************************************/


